﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Xml.Linq;
using System.Text;
using System.Windows.Forms;
using OnlineSzamla;
using System.Xml;
using System.IO;
using System.Diagnostics;

namespace teszt_c
{
    public partial class Main : Form
    {

#region "Description & Changes"

    //' 02.06
    //'• a requestVersion és headerVersion tagekről lekerültek a default értékek, mostantól nem lehet önbezárt taget küldeni ezeknél
    //'• a /queryTaxpayer válaszában új elemek kerültek (infoDate, taxNumberDetail)
    //'• a /queryTaxpayer válaszában a címadat listatípusra módosult (taxpayerAddressItem), a címadatok mellett a taxpayerAddressType elemben a cím típusa (székhely, telephely, fióktelep)
    //'• a /queryInvoiceDigest kérésében az OriginalInvoiceNumberQueryType típus törlésre került, a mandatoryQueryParams/originalInvoiceNumber útvonal mostantól element, nem komplex típus
    //'• a /queryInvoiceDigest kérésében az additionalQueryParams típus bővítésre került a taxNumber paraméterrel, amely a megtalált eredményeket szűkíti a megadott adószámmal (a keresett mező a keresés irányától függ ugyan úgy, ahogy a csomópont többi eleménél). Ezt kell használni a korábbi originalInvoiceNumber/supplierTaxNumber szűrés megadására vevő oldali lekérdezéskor.
    //'• bevezetésre került a /queryInvoiceChainDigest operáció és a hozzá kapcsolódó request/response elemek
    //'• bevezetésre került a /queryTransactionList operáció és a hozzá kapcsolódó request/response elemek


    //'    A számlaadat-szolgáltatás interfész a következő operációkat implementálja.
    //'----------------------------------------------------------------------------------
    //'- /manageAnnulment: a technikai érvénytelenítés beküldésére szolgáló operáció
    //'- /manageInvoice: a számlaadat-szolgáltatás beküldésre szolgáló operáció, ezen keresztül van lehetőség számla vagy módosító okirat adatait a NAV részére beküldeni
    //'- /queryInvoiceChainDigest: számlalánc kivonatos lekérdezésére szolgáló operáció
    //'- /queryInvoiceCheck: számláról történő sikeres adatszolgáltatás ellenőrzésére szolgáló operáció
    //'- /queryInvoiceData: a számlaadatok teljes adattartalmú lekérdezésére szolgáló operáció számlasorszám alapján
    //'- /queryInvoiceDigest: számlaadatok kivonatos lekérdezésére szolgáló operáció, kötelező és opcionális kereső paraméterek alapján
    //'- /queryTransactionList: beküldött tranzakciók lekérdezése megadott időintervallum alapján
    //'- /queryTransactionStatus: számlaadat-szolgáltatás és technikai érvénytelenítés feldolgozási eredményének lekérdezésére szolgáló operáció
    //'- /queryTaxpayer: belföldi adószám validáló operáció, mely a számlakiállítás folyamatába építve képes a megadott adószám valódiságáról és érvényességéről a NAV adatbázisa alapján adatot szolgáltatni
    //'- /tokenExchange: a számlaadat-szolgáltatás és a technikai érvénytelenítés beküldését megelőző egyszer használatos adatszolgáltatási token kiadását végző operáció

#endregion 'Description & Changes


        OnlineSzamla.AppSettings xsettings = new OnlineSzamla.AppSettings();
        
        string version = "Verzió:3.12";
        string creator = "PPSOFT";
        string created = "2020.11.30";
        List<Param> dparam = new List<Param>();


        public Main()
        {
            InitializeComponent();

                    this.Label3.Text = version;
        this.Label5.Text = creator;
        this.Label6.Text = created;

        this.comboBox1.SelectedIndex = 0;

        xsettings =  xsettings.Load();

        Utils.Initparams();
        Utils.initUSer();

            //Utils.login = xsettings.login;
            //Utils.taxNumber = xsettings.taxNumber;
            //Utils.password = xsettings.password;
            //Utils.signKey = xsettings.signKey;
            //Utils.decKey = xsettings.decKey;

           if (!Utils.testToolUsing) 
           {
               this.Check3rdButton.Visible = false;

           }

           this.DirectionComboBox.SelectedIndex = 0;
           this.DirectionComboBox2.SelectedIndex = 0; 


        }


        private void button6_Click(object sender, EventArgs e)
        {

            this.xmlFileTextBox.Text = "";
            if (this.radioButton1.Checked)
            {
            openFileDialog1.Filter = "XML fájlok|*.xml";
            openFileDialog1.Title = "XML fájl";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                this.xmlFileTextBox.Text = openFileDialog1.FileName;
            }
        } 
        else
        {
                this.folderBrowserDialog1.Description = "Válassza ki az XML fájlok könyvtárát";
            this.folderBrowserDialog1.ShowNewFolderButton = false;
            if (folderBrowserDialog1.ShowDialog() == DialogResult.OK) 
                {
                    this.xmlFileTextBox.Text = folderBrowserDialog1.SelectedPath;
                }


        }

        }


        private void button8_Click(object sender, EventArgs e)
        {

            this.textBox7.Text = "";
            if (this.radioButton1.Checked)
            {
                openFileDialog1.Filter = "XML fájlok|*.xml";
                openFileDialog1.Title = "XML fájl";
                if (openFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    this.xmlFileTextBox.Text = openFileDialog1.FileName;
                }
            }
            else
            {
                this.folderBrowserDialog1.Description = "Válassza ki az XML fájlok könyvtárát";
                this.folderBrowserDialog1.ShowNewFolderButton = false;
                if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
                {
                    this.xmlFileTextBox.Text = folderBrowserDialog1.SelectedPath;
                }


            }


        }


        // Menu

        
        private void button1_Click(object sender, EventArgs e)
        {

            Button btn = (Button)sender;
            switch (btn.Text.ToUpper())
            {
                case "MANAGEANNULMENT":
                    manageAnnulment(this.xmlFileTextBox.Text);
                    break;
                case "MANAGEINVOICE":
                    manageInvoice(this.xmlFileTextBox.Text, (ManageInvoiceOperationType)this.comboBox1.SelectedIndex,this.GZIPCheckBox.Checked ) ;
                    break;
                case "QUERYINVOICECHAINDIGEST":
                    queryInvoiceChainDigest();
                    break;
                case "QUERYINVOICECHECK":
                    queryInvoiceCheck();
                    break;
                case "QUERYINVOICEDATA":
                    queryInvoiceData();
                    break;
                case "QUERYINVOICEDIGEST":
                    queryInvoiceDigest();
                    break;
                case "QUERYTRANSACTIONLIST":
                    queryTransactionList();
                    break;
                case "QUERYTRANSACTIONSTATUS":
                    queryTransactionStatus(this.textBox2.Text);
                    break;
                case "TOKENEXCHANGE":
                    tokenExchange();
                    break;
                case "QUERYTAXPAYER":
                    queryTaxPayer(this.textBox4.Text);
                    break;
            }
        }


#region "Implemented operations"

        // manageAnnulment
        private void manageAnnulment(string XMLfile)
        {
            string token = tokenExchange();
            if (string.IsNullOrEmpty(token))
                return;
            SzlaManageAnnulmentRequest marq = new SzlaManageAnnulmentRequest();
            if (this.radioButton1.Checked)
            {
                marq.AddSzamlaXmlfromFile(XMLfile);
            }
            else
            {
                marq.AddSzamlaXmlfromDirectory(XMLfile);
            }
            marq.exchangeToken = token;
            string xmldata = marq.GenXML();
            //XDocument xDocument = XDocument.Parse(xmldata);
            //this.richTextBox1.Text = xDocument.ToString();
            marq.Send(xmldata);
            if (!string.IsNullOrEmpty(marq.response))
            {
                XDocument xDocument2 = XDocument.Parse(marq.response);
                richTextBox2.Text = xDocument2.ToString();
                CStringItem[] array1 = new[] { new CStringItem(marq.Transaction.transactionId) };
                this.dataGridView1.DataSource = array1;
            }
            else
            {
                this.richTextBox2.Text = XDocument.Parse(marq.errorresponse).ToString();
                this.dataGridView1.DataSource = Utils.writeErrorMessages(marq);

            }
        }

        // manageInvoice
        private void manageInvoice(string XMLfile, ManageInvoiceOperationType operation, bool compressed )
        {
            string token = tokenExchange();
            if (string.IsNullOrEmpty(token))
                return;
            SzlaManageInvoiceRequest mirq = new SzlaManageInvoiceRequest();
            if (this.radioButton1.Checked)
                {
                mirq.AddSzamlaXmlfromFile(XMLfile, (int)operation, compressed);
                }
                else
                {
                    mirq.AddSzamlaXmlfromDirectory(XMLfile, (int)operation, compressed);
                }
            mirq.exchangeToken = token;
            string xmldata = mirq.GenXML();
            //XDocument xDocument = XDocument.Parse(xmldata);
            //this.richTextBox1.Text = xDocument.ToString();
            mirq.Send(xmldata);
            if (!string.IsNullOrEmpty(mirq.response))
            {
                XDocument xDocument2 = XDocument.Parse(mirq.response);
                richTextBox2.Text = xDocument2.ToString();
                CStringItem[] array1 = new[] { new CStringItem(mirq.Transaction.transactionId) };
                this.dataGridView1.DataSource = array1;
            }
            else
            {
                this.richTextBox2.Text = XDocument.Parse(mirq.errorresponse).ToString();
                this.dataGridView1.DataSource = Utils.writeErrorMessages(mirq);
                
            }
        }

        // queryInvoiceChainDigest
           private void queryInvoiceChainDigest()
           {

        SzlaQueryInvoiceChainDigestRequest cdrq = new SzlaQueryInvoiceChainDigestRequest();


        //' Possible query options
        //'--------------------------------

        //' mandatory
        //'cdrq.invoiceNumberQuery.invoiceNumber
        //'cdrq.invoiceNumberQuery.invoiceDirection

        //' optional
        //'cdrq.invoiceNumberQuery.batchIndex
        //'cdrq.invoiceNumberQuery.batchIndexSpecified
        //'cdrq.invoiceNumberQuery.supplierTaxNumber
        //'cdrq.invoiceNumberQuery.supplierTaxNumberSpecified

        //' Default value = 1
        cdrq.page = (int)this.indexNumericUpDown.Value;

        InvoiceDirectionType m_direction = (this.DirectionComboBox.SelectedIndex == 0) ?  InvoiceDirectionType.OUTBOUND : InvoiceDirectionType.INBOUND;

        Utils.SetPropertyEx(cdrq, "invoiceChainQuery.invoiceNumber", this.szamlaszamTextBox.Text , true);
        Utils.SetPropertyEx(cdrq, "invoiceChainQuery.invoiceDirection", m_direction, true);

        if  (!string.IsNullOrEmpty(SupAdoszamTextBox.Text)) 
               {
            Utils.SetPropertyEx(cdrq, "invoiceChainQuery.supplierTaxNumber", SupAdoszamTextBox.Text, true);
               }

        String xmldata = cdrq.GenXML();
        // xmladatok mentése

        XDocument xDocument  = XDocument.Parse(xmldata);
        richTextBox1.Text = xDocument.ToString();

        cdrq.Send(xmldata);

               if (! string.IsNullOrEmpty(cdrq.response)) 
               {
            XDocument  xDocument2  = XDocument.Parse(cdrq.response);
            richTextBox2.Text = xDocument2.ToString();
            this.qiCurrentPageTextBox.Text = cdrq.currentPage.ToString();
            this.qiAvailablePageTextBox.Text = cdrq.availablePage.ToString();

            if (cdrq.availablePage > 0) 
               {
                if (cdrq.invoiceChainElement != null) 
               {
                    //' invoicechainDigest
                    //' invoicelines
                    //' invoiceReferenceData

           }
           }


            }
            else
            {
                this.richTextBox2.Text = XDocument.Parse(cdrq.errorresponse).ToString();
                this.dataGridView1.DataSource = Utils.writeErrorMessages(cdrq);
           }
           }

        // queryInvoiceCheck
        private void queryInvoiceCheck()
        {

        SzlaQueryInvoiceCheckRequest ichrq =  new SzlaQueryInvoiceCheckRequest();

        //' mandatory
        //'cdrq.invoiceNumberQuery.invoiceNumber
        //'cdrq.invoiceNumberQuery.invoiceDirection

        //' optional
        //'cdrq.invoiceNumberQuery.batchIndex        //'cdrq.invoiceNumberQuery.batchIndexSpecified
        //'cdrq.invoiceNumberQuery.supplierTaxNumber
        //'cdrq.invoiceNumberQuery.supplierTaxNumberSpecified

        InvoiceDirectionType m_direction = (this.DirectionComboBox.SelectedIndex == 0) ?  InvoiceDirectionType.OUTBOUND : InvoiceDirectionType.INBOUND;

        Utils.SetPropertyEx(ichrq, "invoiceNumberQuery.invoiceNumber", this.szamlaszamTextBox.Text, true);
        Utils.SetPropertyEx(ichrq, "invoiceNumberQuery.invoiceDirection", m_direction, true);

        if  (!string.IsNullOrEmpty(SupAdoszamTextBox.Text)) 
               {
                   Utils.SetPropertyEx(ichrq, "invoiceNumberQuery.supplierTaxNumber", SupAdoszamTextBox.Text, true);
               }


        string  xmldata = ichrq.GenXML();
        // xmladatok mentése

        XDocument xDocument = XDocument.Parse(xmldata);
        richTextBox1.Text = xDocument.ToString();

        ichrq.Send(xmldata);

               if (! string.IsNullOrEmpty(ichrq.response)) 
               {
            XDocument xDocument2  = XDocument.Parse(ichrq.response);
            this.richTextBox2.Text = xDocument2.ToString();
            this.textBox2.Text = ichrq.CheckInvoice.result.message;
            if (ichrq.isFoundInvoice) 
            {
                MessageBox.Show("Beküldött számla");
               }
               else
               {
                   MessageBox.Show("Számla nem található");
            }
            }
            else
            {
                this.richTextBox2.Text = XDocument.Parse(ichrq.errorresponse).ToString();
                this.dataGridView1.DataSource = Utils.writeErrorMessages(ichrq);

               }
        }

        // queryInvoiceData
        private void queryInvoiceData()
        {


           SzlaQueryInvoiceDataRequest idrq = new SzlaQueryInvoiceDataRequest();

        //' Possible query options

           //'idrq.invoiceNumberQuery.invoiceNumber
           //'idrq.invoiceNumberQuery.invoiceDirection

           //'idrq.invoiceNumberQuery.batchIndex
           //'idrq.invoiceNumberQuery.batchIndexSpecified
           //'idrq.invoiceNumberQuery.supplierTaxNumber

           InvoiceDirectionType m_direction = (this.DirectionComboBox.SelectedIndex == 0) ? InvoiceDirectionType.OUTBOUND : InvoiceDirectionType.INBOUND;

           Utils.SetPropertyEx(idrq, "invoiceNumberQuery.invoiceNumber", this.szamlaszamTextBox.Text, true);
           Utils.SetPropertyEx(idrq, "invoiceNumberQuery.invoiceDirection", m_direction, true);

           if (!string.IsNullOrEmpty(SupAdoszamTextBox.Text))
           {
               Utils.SetPropertyEx(idrq, "invoiceNumberQuery.supplierTaxNumber", SupAdoszamTextBox.Text, true);
           }

            string xmldata = idrq.GenXML();
            XDocument xDocument = XDocument.Parse(xmldata);
            this.richTextBox1.Text = xDocument.ToString();
            idrq.Send(xmldata);

            if (!string.IsNullOrEmpty(idrq.response))
            {
                XDocument xDocument2 = XDocument.Parse(idrq.response);
                this.richTextBox2.Text = xDocument2.ToString();

                if (idrq.InvoiceData != null)
                {
                InvoiceDataResultType invoiceResult = idrq.InvoiceData.invoiceDataResult;
                if (invoiceResult != null)
                {

                        System.IO.File.WriteAllText(Path.GetTempPath() + "\\szamla.xml", Utils.PrettyXML(idrq.invoiceXML));
                        this.invoiceButton.Enabled = true;

                        //Auditdata megjelenítése
                        CStringItem[] array1 = new[] { new CStringItem(invoiceResult.auditData.insCusUser), new CStringItem(invoiceResult.auditData.insdate.ToString()), new CStringItem(invoiceResult.auditData.transactionId), new CStringItem(Enum.GetName(typeof(SourceType), invoiceResult.auditData.source)) };
                   this.dataGridView1.DataSource = array1;
                    }
                }



            }
            else
            {
                this.richTextBox2.Text = XDocument.Parse(idrq.errorresponse).ToString();
                this.dataGridView1.DataSource = Utils.writeErrorMessages(idrq);
            }
        }

     
   // queryInvoiceDigest
    private void queryInvoiceDigest()
    {
        
       SzlaQueryInvoiceDigestrequest idrq = new SzlaQueryInvoiceDigestrequest();

       Utils.SetPropertyEx(idrq, "page", System.Convert.ToInt32(this.IndexNumericUpDown2.Value), true);
       Utils.SetPropertyEx(idrq, "invoiceDirection", (this.DirectionComboBox2.SelectedIndex == 0) ? InvoiceDirectionType.OUTBOUND : InvoiceDirectionType.INBOUND, true);

       // idrq.mandatoryQueryParams
       // idrq.additionalQueryParams
       // idrq.relationalQueryParams
       // idrq.transactionQueryParams

       idrq.AddParam("mandatoryQueryParams.invoiceIssueDate.dateFrom", this.tolDateTimePicker.Value.ToString("yyyy-MM-dd"));
       idrq.AddParam("mandatoryQueryParams.invoiceIssueDate.dateTo", this.igDateTimePicker.Value.ToString("yyyy-MM-dd"));

       idrq.AddParam("additionalQueryParams.paymentMethod",((int)PaymentMethodType.TRANSFER).ToString());
       //idrq.AddParam("additionalQueryParams.paymentMethod", PaymentMethodType.TRANSFER);

        
        idrq.AddParam("additionalQueryParams.currency", "HUF");
        
        idrq.AddParam("relationalQueryParams.invoiceDelivery", "2020-01-15", QueryOperatorType.EQ.ToString());

        idrq.AddParam("relationalQueryParams.invoiceNetAmountHUF", "200000", QueryOperatorType.GTE.ToString());
        idrq.AddParam("relationalQueryParams.invoiceNetAmountHUF","300000", QueryOperatorType.LTE.ToString());

        idrq.SetParams();
        
        string xmldata = idrq.GenXML();
        
        // xmladatok mentése

        XDocument xDocument  = XDocument.Parse(xmldata);
        richTextBox1.Text = xDocument.ToString();

        idrq.Send(xmldata);

                    if (!string.IsNullOrEmpty(idrq.response))
                    {
            XDocument xDocument2 = XDocument.Parse(idrq.response);
            richTextBox2.Text = xDocument2.ToString();
            this.TextBox10.Text = idrq.currentPage.ToString();
            this.TextBox9.Text = idrq.availablePage.ToString();

                        //'If idrq.queryResults.availablePage > 0 Then

            //If idrq.DigestResult IsNot Nothing Then
            //    Dim szamlafile As System.IO.StreamWriter
            //    szamlafile = My.Computer.FileSystem.OpenTextFileWriter(My.Computer.FileSystem.SpecialDirectories.Temp + "\szamla.xml", False)
            //    szamlafile.WriteLine(idrq.invoiceXML)
            //    szamlafile.Close()
            //    'Me.invoiceButton.Enabled = True
            //End If


            InvoiceDigestType[] digestlist = idrq.getDigestListArray();
            if (digestlist != null)
                        {
                            this.dataGridView1.DataSource = digestlist;
                        }
            }
            else
            {
                this.richTextBox2.Text = XDocument.Parse(idrq.errorresponse).ToString();
                this.dataGridView1.DataSource = Utils.writeErrorMessages(idrq);
            }

        }

    // queryTransactionList
    private void queryTransactionList()
    {
        SzlaQueryTransactionList tlrq =  new SzlaQueryTransactionList();

        tlrq.page = (int)this.IndexNumericUpDown3.Value;

            DateTime toldate = TolDateTimePickerQtl.Value;
            DateTime Igdate = IgDateTimePickerUtl.Value;

            Utils.SetPropertyEx(tlrq, "insDate.dateTimeFrom", DateTime.SpecifyKind(DateTime.Parse(toldate.ToString("yyyy-MM-ddTHH:mm:ss.fff")), DateTimeKind.Utc), true);
            Utils.SetPropertyEx(tlrq, "insDate.dateTimeTo", DateTime.SpecifyKind(DateTime.Parse(Igdate.ToString("yyyy-MM-ddTHH:mm:ss.fff")), DateTimeKind.Utc), true);


        string xmldata = tlrq.GenXML();
        // xmladatok mentése

        XDocument xDocument = XDocument.Parse(xmldata);
        richTextBox1.Text = xDocument.ToString();

        tlrq.Send(xmldata);
        if (!String.IsNullOrEmpty(tlrq.response)) 
        {
            XDocument xDocument2  = XDocument.Parse(tlrq.response);
            richTextBox2.Text = xDocument2.ToString();
            this.qtlCurrentpageTextBox.Text = tlrq.currentPage.ToString();
            this.qtlAvailablePageTextBox.Text = tlrq.availablePage.ToString();
            if (tlrq.availablePage > 0)
            {

                this.dataGridView1.DataSource = tlrq.transaction;
            }
        }
        else
        {
                this.richTextBox2.Text = XDocument.Parse(tlrq.errorresponse).ToString();
                this.dataGridView1.DataSource = Utils.writeErrorMessages(tlrq);
        }


    }



        // queryInvoiceStatus
        private void queryTransactionStatus(string tranzakcioID)
        {
        
            //Kizárólag a E-mai lküldés demonstrálásához
            //Elküldendő E-mail csatolmányok
            List<string> attachments = new List<string>();

            //Request objektum létrehozása
            SzlaQueryTransactionStatus isrq = new SzlaQueryTransactionStatus();
            //Tranzakció ID beállítása
            isrq.SetTransactionID(tranzakcioID);
            //Kérjük az elküldött számla XML-t?
            isrq.returnOriginalRequest = this.OriginalRequestcheckBox.Checked;
            //Elküldendő (request) XML legenerálása
            string xmldata = isrq.GenXML();
            
            //Elküldendő XML megjelenítése
            XDocument xDocument = XDocument.Parse(xmldata);
            richTextBox1.Text = xDocument.ToString();
            
            //Kizárólag a E-mai lküldés demonstrálásához
            if (this.TrackingCheckBox.Checked) 
            {
                System.IO.File.WriteAllText(Path.GetTempPath() + "\\request.xml", richTextBox1.Text);
                attachments.Add(Path.GetTempPath() + "\\request.xml");
            }


            //XML küldése
            isrq.Send(xmldata);
            
            
            if (!string.IsNullOrEmpty(isrq.response))
            {
                XDocument xDocument2 = XDocument.Parse(isrq.response);
                richTextBox2.Text = xDocument2.ToString();
                if (isrq.InvoiceStatus.result.funcCode == FunctionCodeType.OK)
                {
                    if (isrq.InvoiceStatus.result.message != null)
                        this.textBox2.Text = isrq.InvoiceStatus.result.message;
                    if (isrq.InvoiceStatus.processingResults != null)
                    {
                        this.textBox2.Text = isrq.InvoiceStatus.result.message;
                        this.dataGridView1.DataSource = isrq.getProcessingResultArray();
                    }
                }
            }
            else
            {
                this.richTextBox2.Text = XDocument.Parse(isrq.errorresponse).ToString();
                this.dataGridView1.DataSource = Utils.writeErrorMessages(isrq);
            }
 
            //Kizárólag a E-mai lküldés demonstrálásához
            if (this.TrackingCheckBox.Checked)
            {
                System.IO.File.WriteAllText(Path.GetTempPath() + "\\response.xml", richTextBox2.Text);
                attachments.Add(Path.GetTempPath() + "\\response.xml");
            }


            //Kizárólag a E-mai lküldés demonstrálásához
            if (this.TrackingCheckBox.Checked)
            {

             //Kizárólag a E-mai lküldés demonstrálásához
            if (this.TrackingCheckBox.Checked)
            {
                if ((attachments.Count) > 0) 
                {    
                MessageBox.Show(attachments.Count.ToString() + " csatolmány küldése");
                SendMail(attachments);
            }
            }

            }



        }

        // queryTaxPayer
        private void queryTaxPayer(string taxNumber)
        {
            SzlaQueryTaxpayer qtrq = new SzlaQueryTaxpayer();
            qtrq.SetTaxNumber(this.textBox4.Text);
            string xmldata = qtrq.GenXML();
            XDocument xDocument = XDocument.Parse(xmldata);
            this.richTextBox1.Text = xDocument.ToString();
            qtrq.Send(xmldata);
            if (!string.IsNullOrEmpty(qtrq.response))
            {
                XDocument xDocument2 = XDocument.Parse(qtrq.response);
                this.richTextBox2.Text = xDocument2.ToString();
                this.textBox2.Text = qtrq.TaxPayer.result.message;
                if (qtrq.isValidTaxpayer)
                {
                    MessageBox.Show("Érvényes adószám");
                    this.dataGridView1.DataSource = qtrq.getTaxPayerDatasArray();
                }
                else
                {
                    MessageBox.Show("Érvénytelen adószám");
                }
            }
            else
            {
                this.richTextBox2.Text = XDocument.Parse(qtrq.errorresponse).ToString();
                this.dataGridView1.DataSource = Utils.writeErrorMessages(qtrq);
            }
         
        }

        // tokenExchange
        private string tokenExchange()
        {
            SzlaTokenExchangeRequest tkrq = new SzlaTokenExchangeRequest();
            string xmldata = tkrq.GenXML();
            XDocument xDocument = XDocument.Parse(xmldata);
            richTextBox1.Text = xDocument.ToString();
            tkrq.Send(xmldata);
            if (!string.IsNullOrEmpty(tkrq.response))
            {
                XDocument xDocument2 = XDocument.Parse(tkrq.response);
                richTextBox2.Text = xDocument2.ToString();
                CStringItem[] array1 = new[] { new CStringItem(tkrq.decodedExchangeToken) };
                this.dataGridView1.DataSource = array1;
                return tkrq.decodedExchangeToken;
            }
            else
            {
                this.richTextBox2.Text = XDocument.Parse(tkrq.errorresponse).ToString();
                this.dataGridView1.DataSource = Utils.writeErrorMessages(tkrq);
                return null;
            }
        }

        
        
            private void SendMail(List<String> attachments)
            {
        SMTPEmail myMail = new SMTPEmail(true);
        myMail.AddAttachments(attachments);
        myMail.Send();
            }


#endregion 'Implemented operations'


        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {

              this.richTextBox1.Text = "";
              this.richTextBox2.Text = "";

        if (((TabControl)sender).SelectedTab  == tabPage_version) 
            {
            this.richTextBox1.Text = Utils.History;
            }
 
        }

        private void Button7_Click(object sender, EventArgs e)
        {
            UIUtils.ShowViewer();
        }

        private void CheckButton_Click(object sender, EventArgs e)
        {
            this.richTextBox2.Text = Utils.XsdXmlSchemaValidate(this.xmlFileTextBox.Text, Utils.XSDFilePath);

        }

        private void Check3rdButton_Click(object sender, EventArgs e)
        {
             this.richTextBox1.Text = Utils.XsdXmlValidate(this.xmlFileTextBox.Text, Utils.XSDFilePath);
        }

        private void Button9_Click(object sender, EventArgs e)
        {

                     UIUtils.Settings(xsettings);
                    Utils.Initparams();

        }


        private void Button10_Click(object sender, EventArgs e)
        {
            UIUtils.FileViewer(this.xmlFileTextBox.Text);

        }

        private void RadioButton3_CheckedChanged(object sender, EventArgs e)
        {


        }

        private void invoiceButton_Click(object sender, EventArgs e)
        {
            UIUtils.FileViewer(Path.GetTempPath() + "\\szamla.xml");
        }

        private void ServiceMetricsbutton_Click(object sender, EventArgs e)
        {

            GetMetrics sm = new GetMetrics();
            SendRequestEventArgs SendRequest = new SendRequestEventArgs() {uri = "" };

            sm.Send(SendRequest);
            if (!string.IsNullOrEmpty(sm.response))
            {
                XDocument xDocument2 = XDocument.Parse(sm.response);
                richTextBox2.Text = xDocument2.ToString();
            }
            else
            {
                this.richTextBox2.Text = XDocument.Parse(sm.errorresponse).ToString();
            }
        }
    }
}
